#!/usr/home/rptlab2/bin/python -u
import os, sys, string, traceback, cgi, time
from types import StringType
from rlextra.utils import cgihelp

SAMPLE_XML='sample_ukpython_2003.xml'
SERVER_URL='http://server.reportlab.com/cgi-bin/brochure.cgi'
PDFOUT_URL='http://server.reportlab.com/pdfout/'

form=None
class cgidata:
	def __init__(self):
		self._form = cgi.FieldStorage()
		self._D = {}
		self._setDefaults(
			pdfPS='A4',
			)

	def makeURLArgs(self):
		s = []
		for k, v in self._D.items():
			s.append('%s=%s'%(k,v))
		return string.join(s,'&')

	def has_key(self,k):
		return self._form.has_key(k)

	def __getitem__(self,k):
		try:
			return self._D[k]
		except KeyError:
			return self._form[k].value

	def _setDefaults(self,**kw):
		form, D = self._form, self._D
		for k, v in kw.items():
			if form.has_key(k):
				s = form[k].value
				if type(v) is StringType or isNumber(s):
					v = s
			D[k] = v

FORM='''
<table>
<tr><td colspan="%(NC)d"><table><tr><td><td align="right">Generated by (optional)</td>
	<td align="left"><input type=text name=genBy value="" size=20 maxsize=256></td>
	<td width="50">&nbsp;</td>
	<td align="right">Generated for (optional)</td>
	<td align="left"><input type=text name=genFor value="" size=20 maxsize=256></td>
	</tr></td></table></tr>
%(checks)s
<tr><td colspan=2>&nbsp;</td>
	</tr>
<tr><td align=left><input type=submit name=action value="Get PDF"></td>
	<td align=left>%(select_pdfPS)s</td>
	</tr>
</table>
'''
Blurb='''
ReportLab have built the brochure for the ACCU Conference 2003.  This
is a dynamic document which pulls information from an XML database of talks,
allowing everything to be regenerated in a few seconds if timetables change.
The full brochure is 26 pages and includes many interviews as well as details
of many talks.  The minimal one has fewer pages and just has the essentials.
<p>
Alternatively, you can build your own, and add your name to the
cover!
<hr>
'''

def getConfTree():
	from conftree import ConfTree
	return ConfTree('sample_ukpython_2003.xml')

def doPDF():
	ct = getConfTree()
	D = ct.getDays()
	T = ct.getTracks()
	V = ct.getInterviews()
	F = []
	for t in T:
		for d in D:
			k  = 'd%dt%d' % (D.index(d),T.index(t))
			if form.has_key(k): F.append(k)
	for i in V:
		k  = 'i%d' % V.index(i)
		if form.has_key(k): F.append(k)

	from urllib import urlopen, quote_plus
	genBy = form.has_key('genBy') and ('&generatedBy='+quote_plus(str(form['genBy']).strip())) or ''
	genFor = form.has_key('genFor') and ('&generatedFor='+quote_plus(str(form['genFor']).strip())) or ''
	URL = SERVER_URL+'?action=_dtFilterPdf&document=brochure&data=%s&filter=%s%s%s' % (SAMPLE_XML,','.join(F), genBy,genFor)
	result = urlopen(URL).read()
	filename = result.strip().split()[0]
	return cgihelp.writeResultPage(PDFOUT_URL+filename,
			cgihelp.getScriptName(),
			title = 'ReportLab ACCU Brochure Generation Demo',
			heading = 'ReportLab ACCU Brochure Generation Demo',
			body = '',
			docname='ACCU Conference Brochure',
			filesize=None,
			linkname='your brochure')

def normTime(x):
	x = str(x).split(':')
	if len(x)<2: x = x+ ['00']
	if len(x[0])<2: x[0] = '0'+x[0]
	return ':'.join(x)

def doHTML():
	ct = getConfTree()
	T = ct.getTracks()
	NC = len(T)
	D = ct.getDays()
	checks = []
	a = checks.append
	def cell(c,a=a,cAttr='align="center"'):
		cA = []
		a('<td%s>%s</td>' % (cAttr and ' '+cAttr or '',c))
	a('<tr><td colspan="%d">&nbsp;</td></tr>' % NC )
	cell('<font size=+1><b>Choose Talks</b></font>',cAttr='align="center" colspan="%d"' % NC)
	a('<tr>')
	cell('')
	for t in T:
		if t.lower()!='keynote': cell(t)
	a('</tr>')

	for d in D:
		a('<tr>')
		cell('Day %d' % int(d),cAttr='align="left"')
		for t in T:
			n = 'd%dt%d' % (D.index(d),T.index(t))
			if t.lower()!='keynote':
				cell('<input type="checkbox" name="%s" value="1" checked>' % n)
		a('</tr>')

	keynotes = []
	for i in ct.getItems():
		if str(i.track).lower()=='keynote':
			t = T.index(str(i.track))
			keynotes.append((str(i.day),normTime(i.start), str(i.speaker), str(i.desc).replace('para>','p>')))
	if keynotes:
		keynotes.sort()
		a('<tr><td colspan="%d">&nbsp;</td></tr>' % NC)
		a('<tr><td colspan="%d"><table>' % NC)
		a('<tr>')
		cell('<font size=+1><b>Choose Keynote Speeches</b></font>',cAttr='align="center" colspan="4"')
		a('</tr>')
		a('<tr>')
		cell('<font size=+1>Speaker</font>',cAttr='width=20% align="left" valign="top" colspan=2')
		cell('<font size=+1>Description</font>',cAttr='width=65% align="left" valign="top"')
		cell('<font size=+1>Time</font>',cAttr='width=10% align="right" valign="top"')
		a('</tr>')
		for d,tim,spkr,desc in keynotes:
			a('<tr>')
			n = 'd%dt%d' % (D.index(d),t)
			cell('<b>%s</b>' % ct.getSpeakerFromId(spkr).name,cAttr='align="left" valign="top"')
			cell('<input type="checkbox" name="%s" value="1" checked>' % n, cAttr='valign="top" align="center"')
			cell(desc,cAttr='align="left" valign="top"')
			cell('Day %s %s' % (d,tim),cAttr='align="right" valign="top" nowrap')
			a('</tr>')
		a('</table></td></tr>')

	I = ct.getInterviews()
	if I:
		I.sort()
		a('<tr><td colspan="%d">&nbsp;</td></tr>' % NC)
		a('<tr>')
		cell('<font size=+1><b>Choose Interviews</b></font>',cAttr='align="center" colspan="%d"'%NC)
		a('</tr>')
		for i in I:
			a('<tr>')
			n = 'i%d' % I.index(i)
			cell('<input type="checkbox" name="%s" value="1" checked>' % n, cAttr='width="5%" valign="top" align="left"')
			cell(i,cAttr='align="left" valign="top"')
			a('</tr>')

	checks = ''.join(checks)

	select_pdfPS = 'PDF Page Size: '+cgihelp.makeHTMLSelect('pdfPS',('A4','letter'),form['pdfPS'])
	select_pdfPS = ''
	return cgihelp.writeQueryPage(cgihelp.getScriptName(),
					title = 'ReportLab ACCU Brochure Generation Demo',
					heading = 'ReportLab ACCU Brochure Generation Demo',
					body=Blurb,
					preform='<p><center>Select your options and press the button below to make the PDF.</center></p>',
					form = FORM % locals() )

def run():
	global form
	form = cgidata()
	sys.stderr = sys.stdout
	try:
		if form.has_key('action') and form['action']=='Get PDF':
			s = doPDF()
		else:
			s = doHTML()
		print "Content-type: text/html"
		print
		print s
	except:
		print "Content-type: text/html"
		print
		print '<html><head></head><body text=#ff0000><pre>'
		traceback.print_exc()
		print '</pre></body></html>'

if __name__ == '__main__':
	run()
