from reportlab import rl_config
from reportlab.lib.colors import Color, black, white
from reportlab.platypus import Flowable
#from xmlutils import *
import os

_columns=None
_data=None

def _addLunch():
	global _columns, _data
	colx = {}
	for d in ('day', 'start','duration','track','status'): colx[d] = _columns.index(d)
	_data = filter(lambda row,x=colx['status'],t=colx['start']: row[x]=='accepted' and row[t]!='00:00',_data)
	row = (len(_columns)*[''])[:]
	for day in ('1','2','3'):
		row[colx['day']] = day
		row[colx['track']] = 'Coffee'
		for s,d in (('08:30','30'),('10:30','30'),('15:00','30')):
			row[colx['start']] = s
			row[colx['duration']] = d
			_data.append(row[:])
		row[colx['track']] = 'Lunch'
		row[colx['start']] = '12:30'
		row[colx['duration']] = '60'
		_data.append(row[:])
		row[colx['track']] = 'MDFL'
		row[colx['start']] = '17:00'
		row[colx['duration']] = '15'
		_data.append(row[:])
	_data.sort()

##def readCSV(file='talks.csv'):
##	global _columns, _data
##	if _columns or _data:
##		return _columns, _data
##	if os.path.isfile('talks.marshal'):
##		_columns = ['day',
##					'start',
##					'duration',
##					'track',
##					'title',
##					'description',
##					'author',
##					'email',
##					'company',
##					'url',
##					'biography',
##					'room',
##					'kind',
##					'session_nr',
##					'status',
##					]
##		import marshal
##		_data = marshal.load(open('talks.marshal','rb'))
##		_addLunch()
##		return _columns, _data
##
##	import DSV
##	_data = open(file,'rb').read()
##	qualifier = DSV.guessTextQualifier(_data)
##	_data = DSV.organizeIntoLines(_data, textQualifier = qualifier)
##	delimiter = DSV.guessDelimiter(_data)
##	_data = DSV.importDSV(_data, delimiter = delimiter, textQualifier = qualifier)
##	hasHeader = DSV.guessHeaders(_data)
##	if hasHeader: 
##		_columns = _data[0]
##		del _data[0]
##	else:
##		_columns = None
##	T = []
##	tIndex = _columns.index('track')
##
##	for l in _data:
##		if len(l)<=tIndex: continue
##		if l[tIndex] not in T: T.append(l[tIndex])
##	_addLunch()
##	return _columns, _data

####def readXML(file='sample_epc_2002.xml'):
####	#modified from readCSV
####	global _columns, _data
####	if _columns or _data:
####		return _columns, _data
####	if os.path.isfile('talks.marshal'):
####		_columns = ['day',
####					'start',
####					'duration',
####					'track',
####					'title',
####					'description',
####					'author',
####					'email',
####					'company',
####					'url',
####					'biography',
####					'room',
####					'kind',
####					'session_nr',
####					'status',
####					]
####		import marshal
####		_data = marshal.load(open('talks.marshal','rb'))
####		_addLunch()
####		return _columns, _data
####
####	c = 0
####	_columns = ['day',
####				'start',
####				'duration',
####				'track',
####				'title',
####				'description',
####				'author',
####				'email',
####				'company',
####				'url',
####				'biography',
####				'room',
####				'kind',
####				'session_nr',
####				'status'
####				]
####
####	data = open(file,'rb').read()
####	for chunk in data.program_items._namedChildren('item'):
####		_data[c] = [chunk.day,
####					chunk.start,
####					chunk.duration,
####					chunk.track,
####					chunk.title,
####					chunk.description,
####					chunk.author,
####					chunk.email,
####					chunk.company,
####					chunk.url,
####					chunk.biography,
####					chunk.room,
####					chunk.kind,
####					chunk.session_nr,
####					chunk.status
####					]		
####	T = []
####	tIndex = _columns.index('track')
####
####	for l in _data:
####		if len(l)<=tIndex: continue
####		if l[tIndex] not in T: T.append(l[tIndex])
####	_addLunch()
####	return _columns, _data


##class TrackDef:
##	def __init__(self,text,special=0,bg=None,fontName=None,fontSize=None, density=0.2):
##		self.text = text
##		self.special = special
##		self.bg = Color(1+density*(bg[0]/255.-1),1+density*(bg[1]/255.-1),1+density*(bg[2]/255.-1))
##		self.fontName = fontName
##		self.fontSize= fontSize
##
##TrackMap={'Coffee': TrackDef('Coffee',special=1,bg=(6,255,131)),
##		'Tutorial': TrackDef('Python Tutorials',bg=(137,255,255)),
##		'ZopeTutorials': TrackDef('Zope Tutorials',bg=(135,135,255)),
##		'PythonInScienceAndIndustry': TrackDef('Python in Science\n& Industry',bg=(255,132,192)),
##		'Lunch': TrackDef('Lunch',special=1,bg=(6,255,131)),
##		'MDFL': TrackDef('',special=1,bg=(6,255,131)),
##		'Zope': TrackDef('Zope',bg=(135,135,255)),
##		'PythonHackers': TrackDef('Python Language',bg=(137,255,255)),
##		'Keynotes':TrackDef('Keynotes',bg=(255,255,0), special=2),
##		'PythonInBusiness':TrackDef('Python Business',bg=(132,132,70)),
##		'PythonApplications':TrackDef('Python Applications',bg=(255,132,70)),
##		'WebServices':TrackDef('Web Services',bg=(194,194,194)),
##		'ZopeBofs':TrackDef('Zope BoFs',bg=(255,255,255)),
##		'BusinessBofs':TrackDef('Business BoFs',bg=(255,255,255)),
##		'PythonBofs':TrackDef('Python BoFs',bg=(255,255,255)),
##		'LightningTalks':TrackDef('Lightning Talks',bg=(255,255,255)),
##		}
##
##def trackFix(track):
##	"simple routine to make track something suitable for use by titleAbstractBiogs"
##	track = TrackMap[track].text.replace('\n',' ')
##	return	track.replace('&','&amp;')
##
##def trackDict():
##	D = {}
##	for k in TrackMap.keys():
##		if k not in ('Coffee', 'Lunch', 'MDFL'): D[k] = trackFix(k)
##	return D

def stopTime(start,duration):
	h, m = map(int, start.split(":"))
	d = int(duration)
	m += d
	while m>=60:
		h += 1
		m -= 60
	h, m = str(h), str(m)
	if len(h)<2: h = "0"+h
	if len(m)<2: m = "0"+m
	return h+":"+m

def getInfoForDay(data,day=1,am=1):
	columns, data = _columns,_data
	colx = {}
	for c in columns: colx[c] = columns.index(c)
	if am:
		start = '00:00'
		stop='13:00'
	else:
		start = '13:30'
		stop='18:00'

	def f(x,start=start, stop=stop, day = str(day), colx=colx):
		if x[colx['day']]!=day: return 0
		s = x[colx['start']]
		return s>=start and s<stop

	data = filter(f,data)
	data.sort()
	return colx, data

def findHeight(C,width):
	if type(C) is type([]):
		H = 0
		for P in C:
			w,h = P.wrap(width,9999999)
			delattr(P,'blPara')
			H += h
		return H
	else:
		w,h = C.wrap(width,9999999)
		delattr(C,'blPara')
		return h

def shrinkToFit(width,height,C,TS):
	if findHeight(C,width)<=height: return C
	import copy
	NTS = copy.deepcopy(TS)
	fs0 = TS.fontSize
	for i in xrange(99,0,-1):
		f = i/100.
		NTS.fontSize = TS.fontSize*f
		NTS.leading = TS.leading*f
		NTS.bulletFontSize = TS.bulletFontSize*f
		NTS.leftIndent = TS.leftIndent*f
		NTS.rightIndent = TS.rightIndent*f
		NTS.firstLineIndent = TS.firstLineIndent*f
		NTS.spaceBefore = TS.spaceBefore*f
		NTS.spaceAfter = TS.spaceAfter*f
		if type(C) is type([]):
			NC = []
			for P in C:
				NC.append(P.__class__(P.text,style=NTS))
		else:
			NC = C.__class__(C.text,style=NTS)
		if findHeight(NC,width)<=height: return NC
	return C

def subTable(width,height,P):
	from reportlab.platypus.tables import Table
	widths = [width]
	heights = [height]
	h = findHeight(P,0.6*width)
	if h>0.9*height:
		P = shrinkToFit(0.6*width,0.9*height,P,P.style)
		h = findHeight(P,0.6*width)
	topPadding = bottomPadding = (height - h)*0.5 - .1
	leftPadding = rightPadding = 0.2*width
	tstyle = [
			('VALIGN',(0,0),(-1,-1),'TOP'),
			('BOTTOMPADDING',(0,0),(-1,-1),bottomPadding),
			('TOPPADDING',(0,0),(-1,-1),topPadding),
			('LEFTPADDING',(0,0),(-1,-1),leftPadding),
			('RIGHTPADDING',(0,0),(-1,-1),rightPadding),
			]
	return Table([[P]],colWidths=widths,rowHeights=heights,style=tstyle)

from reportlab.graphics.shapes import Drawing
from reportlab.graphics.widgets.grids import ShadedRect
class BGShadedRect(Drawing):
	def __init__(self,width=0,height=0,color=None):
		Drawing.__init__(self,width,height)
		self.add(ShadedRect(),name='sr')
		self._color = color
	def wrap(self,availHeight,availWidth):
		return 0, 0
	def __call__(self,tbl,canv,x,y,w,h):
		old = self.width, self.height
		self.width, self.height = w, h
		self.sr.width, self.sr.height = self.width, self.height
		self.sr.strokeColor, self.sr.fillColorStart, self.sr.fillColorEnd = None, white, self._color
		self.drawOn(canv,x,y)
		self.width, self.height = old

def _getTimeTable(_data,desiredDay,am):
	from reportlab.platypus.tables import Table, Paragraph, PageBreak, KeepTogether
	from reportlab.lib.styles import ParagraphStyle
	TS = ParagraphStyle('tt_title',fontSize=10,leading=10*1.2)
	colx, data = getInfoForDay(_data,desiredDay,am)
	leftPadding = rightPadding = topPadding = bottomPadding = 3
	tdata = [['Room A','Room B','Room C']]
	tstyle = [('FONT',(0,0),(-1,-1),TS.fontName,TS.fontSize,TS.leading),
			('VALIGN',(0,0),(-1,-1),'TOP'),
			('ALIGN',(0,0),(-1,0),'CENTER'),
			('BOTTOMPADDING',(0,0),(-1,-1),bottomPadding),
			('TOPPADDING',(0,0),(-1,-1),topPadding),
			('LEFTPADDING',(0,0),(-1,-1),leftPadding),
			('RIGHTPADDING',(0,0),(-1,-1),rightPadding),
			('BOX',(0,0),(-1,-1),2,black),
			]
	row = 0
	if am:
		heights = [None,0.4*72,2*72,0.4*72,2*72,0.5*72]
		heights = [None,0.18*72,1.8*72,0.18*72,1.8*72,0.2*72]
		starts = [None,"08:30","09:00","10:30","11:00","12:30"]
		stops = [None,"09:00","10:30","11:00","12:30","13:30"]
		map(tstyle.append,(
			('LINEABOVE',(0,1),(-1,-1),1,black),
			('LINEBELOW',(0,1),(-1,-1),1,black),
			('LINEBEFORE',(0,2),(-1,2),1,black),
			('LINEAFTER',(0,2),(-1,2),1,black),
			('LINEBEFORE',(0,4),(-1,4),1,black),
			('LINEAFTER',(0,4),(-1,4),1,black),
			('BACKGROUND',(0,0),(-1,-1), white),
			))
	else:
		heights = [None,1.8*72,0.18*72,1.8*72,0.1*72,0.3*72]
		starts = [None,"13:30","15:00","15:30","17:00","17:15"]
		stops = [None,"15:00","15:30","17:00","17:15","18:00"]
		map(tstyle.append,(
			('LINEABOVE',(0,0),(-1,3),1,black),
			('LINEBELOW',(0,0),(-1,3),1,black),
			('LINEBEFORE',(0,1),(-1,1),1,black),
			('LINEAFTER',(0,1),(-1,1),1,black),
			('LINEBEFORE',(0,3),(-1,3),1,black),
			('LINEAFTER',(0,3),(-1,3),1,black),
			('LINEABOVE',(0,0),(-1,4),0.5,black),
			('LINEBELOW',(0,0),(-1,4),1,black),
			('BACKGROUND',(0,0),(-1,-1), white),
			))
	widths = 3*[451/3.0]
	colh = 'start','duration', 'track', 'author', 'title', 'room'
	nRows = len(heights)
	for i in heights:
		if i is None: continue
		tdata.append((len(tdata[0])*[''])[:])
	for d in data:
		colv = []
		for x in colh: colv.append(d[colx[x]])
		start,duration,track,author,title,room = colv
		row  = None
		for i in xrange(nRows):
			if starts[i] is not None and start>=starts[i] and start<=stops[i]: 
				row = i
		if row is None:
			print >>sys.stderr, "No row for "+title
			continue
		track = TrackMap[track]
		stop = stopTime(start,duration)
		if track.special:
			if track.special==1:
				text = "<b>%s-%s</b>: <font size=+1>%s</font>"%(start,stop,track.text)
			else:
				text = "<font size=-1><b>%s-%s</b></font>: \"%s\", <i>%s</i>."%(start,stop,title, author)
			if track.text!='': tdata[row] = [subTable(451,heights[row],Paragraph(text,TS)),'','']
			for s in (('BACKGROUND',(0,row),(-1,row), BGShadedRect(color=track.bg)),
						('TOPPADDING',(0,row),(-1,row),0),
						('LEFTPADDING',(0,0),(-1,-1),leftPadding),
						):
				tstyle.append(s)
		else:
			col = ord(room.lower())-ord('a')
			cell = tdata[row][col]
			if cell=='':
				cell = []
				tstyle.append(('BACKGROUND',(col,row),(col,row),BGShadedRect(color=track.bg)))
			cell.append(Paragraph("<font size=-1><b>%s-%s</b></font>: \"%s\", <i>%s</i>."%(start,stop,title, author),style=TS))
			tdata[row][col] = cell
	for row in xrange(nRows):
		for col in xrange(len(widths)):
			cell = tdata[row][col]
			if type(cell) is type([]):
				tdata[row][col] = shrinkToFit(widths[col]-leftPadding-rightPadding,heights[row]-topPadding-bottomPadding,cell,TS)
	return Table(tdata,style=tstyle,colWidths=widths,rowHeights=heights)

def getTimeTable(_data,_columns):
	from reportlab.platypus import Spacer, PageBreak
	L = []
	for day in 1,2,3:
		for am in 1,0:
			if day==3 and not am: continue
			map(L.append,(Spacer(0,0.5*72),_getTimeTable(_data,_columns,day,am),PageBreak()))
	return L

def getURLImage(url,width=None,height=None):
	from reportlab.platypus import Image
	from reportlab.lib.utils import open_for_read
	import timetable, os, urlparse
	URL = urlparse.urlparse(url)
	cache_dir = os.path.join(os.path.dirname(timetable.__file__),'url_cache')
	if not os.path.isdir(cache_dir): os.mkdir(cache_dir)
	cache_fn = os.path.join(cache_dir,URL[0]+'_'+URL[1]+URL[2].replace('/','_'))
	if int(os.environ.get('RL_GETIMAGES','0')) or not os.path.isfile(cache_fn):
		open(cache_fn,'wb').write(open_for_read(url).read())
	return Image(cache_fn,width=width,height=height)

def getTTImage(day,width=None,height=None):
	return getURLImage("http://europython.zope.nl/images/schedule_day"+`day`,width=width,height=height)

##def titleAbstractBiogs(styles,T):
##	if T is None: T = trackDict().keys()
##	#from reportlab.platypus import Paragraph, Spacer, CondPageBreak
##	columns, data = readXML()
##	colx = map(columns.index,('author','title','description','biography', 'day', 'start', 'track'))
##	colx = {}
##	for d in columns: colx[d] = columns.index(d)
##	D = []
##	for d in data:
##		t = d[colx['track']]
##		if t in T:
##			D.append((trackFix(t),d[colx['day']], d[colx['start']], d[colx['title']],d[colx['author']],d[colx['description']], d[colx['biography']]))
##	D.sort()
##
##	story=[]
##	biogs={}
##	cTrack = None
##	for d in D:
##		track, day, start, title, author, abstract, biog = d
##		if title.find('Part II')>=0: continue
##		title = title.replace(': Part I','')
##		if title and author and abstract:
##			story.append(CondPageBreak(36))
##			if cTrack!=track:
##				cTrack = track
##				story.append(Paragraph(track,styles['h3']))
##			story.append(Paragraph("<b>%s</b>, %s" % (title, author),styles['Normal']))
##			story.append(Paragraph("day: %s, time: %s" % (day, start),styles['Normal']))
##			story.append(Spacer(height=3, width=10))
##			story.append(Paragraph(abstract,styles['2col']))
##			if biog:
##				if not biogs.has_key(author):
##					story.append(Spacer(0,12))
##					story.append(Paragraph(biog,styles['2col']))
##					biogs[author] = 1
##			story.append(Spacer(0,18))
##	return story

def testtable():
    from reportlab.platypus.tables import Table
    #widths = [width]
    #heights = [height]
    #h = findHeight(P,0.6*width)
    #topPadding = bottomPadding = (height - h)*0.5 - .1
    #leftPadding = rightPadding = 0.2*width
    tstyle = [
            ('VALIGN',(0,0),(-1,-1),'TOP'),
            ('BOTTOMPADDING',(0,0),(-1,-1),3),
            ('TOPPADDING',(0,0),(-1,-1),3),
            ('LEFTPADDING',(0,0),(-1,-1),3),
            ('RIGHTPADDING',(0,0),(-1,-1),3),
            ]
    return Table([['text', 'text'], ['text', 'text']],colWidths=[100,100],rowHeights=[30,30],style=tstyle)

class TimeTableFlowable(Flowable):
    def __init__(self, data):
        self.data = data
        self.table = testtable()
        #self.desiredDay,self.am = string.split(data, ',')
        #self.table = _getTimeTable(desiredDay,am)
        ##self.table = testtable

    def wrap(self, w, h):
        return self.table.wrap(w,h)

    def wrapOn(self,canv, aW, aH):
        w, h = self.table.wrapOn(canv,aW,aH)
        return w, h

    def _drawOn(self,canv):
        self.table._drawOn(canv)


def main():
	from reportlab.platypus import SimpleDocTemplate
	lst = getTimeTable(file='sample_epc_2002.xml')
	from brochure import makeNewStyleSheet
	titleAbstractBiogs(makeNewStyleSheet(),lst)
	SimpleDocTemplate('timetable.pdf',showBoundary=1).build(lst)

if __name__=='__main__':	#noruntests
	main()
