#plugin to hold any plugins for flyers or catalogs

def _handleText(t,x,y,align,dfsize=10):
    text = str(t)
    if not text: return ''
    face = t._value("face", "Times-Roman")
    size = t._value("size", str(dfsize))
    fill = t._value("fill", "black")
    stroke = t._value("stroke", "")
    strokewidth = t._value("strokewidth", "0")
    if stroke and stroke.lower() != "none":
        stroke = '<stroke color="%s" width="%s"/>'%(stroke,strokewidth)
    else:
        stroke = ''
    if align=='left': align = ''
    elif align=='right': align='Right'
    elif align in ('center','centre','middle'): align='Centred'
    else: raise ValueError, 'bad align value: '+align
    
    return """<setFont name="%(face)s" size="%(size)s"/>
%(stroke)s
<fill color="%(fill)s"/>
<draw%(align)sString x="%(x)s" y="%(y)s">%(text)s</draw%(align)sString>""" % locals()

def handleText(t):
    x = t.x
    y = t.y
    align = t._value('align','left').lower()
    return _handleText(t,x,y,align)

def handleImage(t):
    x = t.x
    y = t.y
    name = t.name
    width = t._value("width", "")
    if width:
        width = 'width="%s" ' % width
    height = t._value("height", "")
    if height:
        height = 'height="%s"'% height
    return """<image file="%(name)s" x="%(x)s" y="%(y)s"
    %(width)s %(height)s/>""" % locals()

def handleWidget(t):
    return "<!-- This would be a widget if we had done widgets yet -->"

def handleSplat(t):
    from rlextra.rml2pdf.rml2pdf import readLength
    coords = [(-162, 11), (-51, 30), (-45, 93), (1, 38), (41, 87), (46, 36), (154, 63), (77, 6), (163, -55), (53, -26), (49, -109), (-12, -34), (-73, -83), (-63, -9)]
    w0 = 163+162
    h0 = 109+93
    x = readLength(t.x)
    y = readLength(t.y)
    width = readLength(t._value("width", str(w0)))
    height = readLength(t._value("height", str(h0)))
    fill = t._value("background", "")
    if fill and fill.lower != 'none':
        fill = '<fill color="%s"/>'%fill
    else:
        fill = ''
    stroke = t._value("border", "red")
    strokewidth = t._value("borderwidth", "1")
    if stroke and stroke.lower!='none':
        stroke = '<stroke color="%s" width="%s"/>'%(stroke,strokewidth)
    else:
        stroke = ''
    xmul = width/float(w0)
    ymul = height/float(h0)
    s = stroke+fill
    s += '<path close="1"'
    if fill: s+=' fill="1"'
    if stroke: s+=' stroke="1"'
    def xytrans((xc,yc),xmul=xmul,ymul=ymul,x=x,y=y):
        xc *= xmul
        yc *= ymul
        return (xc+x, yc+y)

    s += ' x="%s" y="%s">' % xytrans(coords[0])
    for xy in coords[1:]:
        s += '%s %s ' % xytrans(xy)
    s += '</path>'
    s += _handleText(t,x,y-10*ymul,'middle',dfsize=36*min(xmul,ymul))
    return s

fMap={'text':handleText,'image':handleImage,'widget':handleWidget,'splat':handleSplat}
def handleTag(t):
    return fMap[t.tagName](t)
