#copyright ReportLab Inc. 2000-2003
#see license.txt for license details
#history www.reportlab.co.uk/rl-cgi/viewcvs.cgi/rlextra/ers/testwebapp.py
#$Header: /rl_home/repository/rlextra/ers/test/test_webapp.py,v 1.2 2003/04/11 09:41:06 andy Exp $

__version__=''' $Id'''
__doc__="""Beginning of a test suite for web apps.

No real test strategy yet..."""

import os, sys, pprint
from reportlab.test import unittest
from reportlab.test.utils import makeSuiteForClasses
from rlextra.ers.webapp import WebApp, WebRequest, WebResponse

class WebAppTestCase(unittest.TestCase):
    "Tests on simple web app components"

    def testResponse(self):
        resp = WebResponse()
        resp.setContentType('text/plain')
        resp.write('This is a rather simple example:\n')
        resp.write('Just two lines of text\n')
        resp.getOutput()
        

    def testDefaultAction(self):
        req = WebRequest()
        resp = WebApp().handleRequest(req)
        assert resp.containsText('alive')
        
    def testPing(self):
        req = WebRequest()
        req.params = {'action':'ping'}
        resp = WebApp().handleRequest(req)
        assert resp.containsText('pong')
        
def makeSuite():
    return makeSuiteForClasses(WebAppTestCase)


#noruntests
if __name__ == "__main__":
    unittest.TextTestRunner().run(makeSuite())