
# generator for tag reference

# XXXX ultimately this should be somehow automated.

debug = 0
if not debug:
    import sys
    outfile = "tagref.rml"
    print "redirecting stdout to", outfile
    sys.stdout = open(outfile, "w")

import string, types

def e(s):
    s = string.replace(s, "<", "&lt;")
    s = string.replace(s, ">", "&gt;")
    return s

# print the prolog
print """\
<!DOCTYPE document SYSTEM "rml_1_0.dtd"> 
<document filename="tagref.pdf"><template>
    <pageTemplate id="main">
    <frame id="first" x1="72" y1="72" width="451" height="698"/> 
    </pageTemplate>
</template>
<stylesheet>
</stylesheet>
<story>
<h1>RML Tag Quick Reference</h1>
<para>
All attributes are optional unless otherwise specified.
</para>
"""

def d(**kw):
    return kw

class tag:
    fontsize = 10
    extra = 5
    # tagname attr=value type comment
    fonts = ("Courier", "Courier", "Helvetica", "Helvetica-Oblique", )
    columns = ("0", "1in", "3.6in", "5.2in")
    colors = ("black", "blue", "green", "red")
    def __init__(self, name, attributeLines=(), contentLines=()):
        self.name = name
        self.attributeLines = attributeLines
        self.contentLines = contentLines
    def __repr__(self):
        n = self.name
        a = self.attributeLines
        c = self.contentLines
        stringOps = []
        add = stringOps.append
        nLines = 1
        #yoffset = self.fontsize + self.extra
        yoffset = 0
        delta = self.fontsize + self.extra
        if a:
            add((yoffset, "&lt;"+self.name))
        elif c:
            add((yoffset, "&lt;"+self.name+"&gt;"))
        else:
            add((yoffset, "&lt;"+self.name+"/&gt;"))
        yoffset = yoffset+delta
        for al in self.attributeLines:
            add((yoffset, None,)+al)
            yoffset = yoffset+delta
        if c and a:
            add((yoffset, "&gt;"))
            yoffset = yoffset+delta
        elif a:
            add((yoffset, "/&gt;"))
            yoffset = yoffset+delta
        for c in self.contentLines:
            tc = type(c)
            if tc is types.StringType:
                add((yoffset, c,))
            elif tc is types.TupleType:
                add((yoffset, c[0], None, None)+c[1:])
            yoffset = yoffset+delta
        if c:
            add((yoffset, "&lt;/%s&gt;" % self.name))
        else:
            # a bit hacky, for some reason the yoffset goes to far in this case
            yoffset = yoffset-delta
        outLines = []
        maxY = yoffset + delta
        nlines = 1
        Ops = []
        addop = Ops.append
        for s in stringOps:
            yoffset = maxY-s[0]
            s = s[1:]
            for i in range(len(s)):
                si = s[i]
                #print i, si
                if si is not None:
                    si = e(si)
                    addop('<setFont name="%s" size="%s"/>' % (self.fonts[i], self.fontsize))
                    addop('<fill color="%s"/>'% self.colors[i])
                    addop('<stroke color="%s"/>' %(self.colors[i],))
                    addop('<drawString x="%s" y="%s">%s</drawString>'%(self.columns[i],yoffset,si))
        addop('<fill color="plum"/>')
        addop('<stroke color="plum"/>')
        addop('<rect x="-10" y="0" height="%s" width="%s" fill="true"/>' %(maxY+delta, -5))
        allOps = string.join(Ops, "\n")
        return """
        <condPageBreak height="2in"/>
            <h3>%s</h3>
        <illustration height="%s" width="%s">
        %s
        </illustration>\n\n""" % (n, maxY+delta, 1, allOps)

def t(*args):
    print apply(tag, args)

def p(s):
    print """<para>%s</para>""" % (s,)

def h1(s):
    print """\n<condPageBreak height="2in"/>
    <spacer length="0.2in"/>
    <h1>%s</h1>\n\n""" % s

##def test1():
##    print tag("name", [('attr="val"', "type", "comment")], ["line1","line2"])
##
##test1()
    

t("document", [('filename="myfile.pdf"', "string", "required")],
          ["<template...>...</template>",
           "<stylesheet...>...</stylesheet>",
           "<story...>...</story>",
           ])

p("Above is the story based form for the document tag.")

t("document", [('filename="myfile.pdf"', "string", "required")],
          [
           "<stylesheet>...</stylesheet>",
           ("<pageInfo>...</pageInfo>", "optional"),
           ("<pageDrawing>...</pageDrawing>", "one or more"),
           ])
p("Above is the PageDrawing based form for the document tag.")
p("""The document tag is the root tag for RML docuements.  Every RML document must contain on and
only one document tag.  There are two forms for a document: the story form and the pageDrawing form.""")

t("template",
  [('pageSize="(8.5in, 11in)"', "pair of lengths"),
    ('leftMargin="1in"', "length"),
    ('rightMargin="1in"', "length"),
    ('topMargin="1.5in"', "length"),
    ('bottomMargin="1.5in"', "length"),
    ('showBoundary="false"', "truth value"),
    ('allowSplitting="true"', "truth value"),
   ('title="my title"', "string"),
   ('author="yours truly"', "string"),
    ],
  [("<pageTemplate...> ...</pageTemplate>", "1 or more"),
   ])

t("stylesheet",
  [],
  [("<initialize>...</initialize>", "optional"),
   ("<paraStyle ... />", "(any number"),
   ("<blockTableStyle>...</blockTableStyle>", "of styles)")
   ])

t("story", [],
  [("<para>...</para>", "(Sequence of"),
   ("...", "top level"),
   ("<illustration>...</illustration>", "flowables)")])

t("pageInfo", [('pageSize="(8.5in,11in)"', "pair of lengths", "required")])

t("pageDrawing", [],
  [("<drawString ...> ...</drawString>", "(Sequence of"),
   ("...", "graphical"),
   ("<place ...>...</place>", "operations)")])

t("pageGraphic", [],
  [("<drawString ...> ...</drawString>", "(Sequence of"),
   ("...", "graphical"),
   ("<place>...</place>", "operations)")])


h1("Generic Flowables (Story Elements)")

t("spacer", [('length="1.2in"', "measurement", "required"),
             ('width="5in"', "measurement"),
              ])

t("illustration", [('height="1.2in"', "measurement", "required"),
             ('width="5in"', "measurement", "required"),
              ],
  [("<drawString ...> ...</drawString>", "(Sequence of"),
   ("...", "graphical"),
   ("<place ...>...</place>", "operations)")])

t("pre", [('style="myfavoritestyle"', "string paragraph style name")],
  [("Preformatted Text", "also string forms (getname)")])

t("plugInFlowable", [('module="mymodule"', "string", "required"),
                     ('function="myfunction"', "string", "required")],
  [("string data for plug in", "unformatted data")])

print("<h2>Table Elements</h2>")

t("blockTable", [
    ('style="mytablestyle"', "string style name"),
    ('rowHeights="(23, 20, 30, 10)"', "sequence of measurement"),
    ('colWidths="50, 90, 35, 11"', "sequence of measurement"),
    ],
  [ ("<tr>...</tr>", "(rows of"),
    ("<tr>...</tr>", "same length)"),
    "..."
      ])

t("tr", [],
  ["<td>...</td>", "<td>...</td>", "..."
      ])

t("td", [],
  [  "string of string form", "or sequence of flowable"
      ])

print "<h2>Paragraph-like Elements</h2>"

t("para",
  [('style="myfavoritstyle"', "string paragraph style name")],
  ["Paragraph text which may contain", "intraparagraph markup"])

t("title",
  [('style="myfavoritstyle"', "string paragraph style name")],
  ["Paragraph text which may contain", "intraparagraph markup"])

t("h1",
  [('style="myfavoritstyle"', "string paragraph style name")],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("h2",
  [('style="myfavoritstyle"', "string paragraph style name")],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("h3",
  [('style="myfavoritstyle"', "string paragraph style name")],
  ["Paragraph text which may contain", "intraparagraph markup"])

print "<h2>Intra-Paragraph Markup</h2>"

t("i",
  [],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("b",
  [],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("font",
  [('face="Helvetica"', "string font name"),
   ('color="blue"', "string color name"),
   ('size="34"', "fontsize measurement"),
      ],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("greek",
  [],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("sub",
  [],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("super",
  [],
  ["Paragraph text which may contain", "intraparagraph markup"])
t("seq",
  [('id="SecNum"', "string"),
   ('template="%(Ch)s.%(SecNum)s"', "string"),
      ]
  )
t("seqDefault",
  [('id="SecNum"', "string"),
      ])
t("seqReset",
  [('id="SecNum"', "string"),
      ])

print "<h2>Page Level Flowables</h2>"

t("nextFrame")

t("setNextTemplate",
  [('name="indextemplate"', "string template name", "required"),
      ])

t("condPageBreak",
  [('height="10cm"', "measurement", "required"),
      ])

t("storyPlace", [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
   ('width="5in"', "measurement", "required"),
   ('height="3in"', "measurement", "required"),
   ('origin="page"', "page|frame|local", "optional"),
   ],
  [("<para>...</para>", "(Sequence of"),
   ("...", "top level"),
   ("<table>...</table>", "flowables)")])

h1("Graphical Drawing Operations")

t("drawString",
  [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
      ],
  ["text to draw or string forms"])

t("drawRightString",
  [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
      ],
  ["text to draw or string forms"])

t("drawCentredString",
  [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
      ],
  ["text to draw or string forms"])


t("ellipse",
  [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
   ('width="5cm"', "measurement", "required"),
   ('height="3cm"', "measurement", "required"),
   ('fill="true"', "truth value"),
   ('stroke="false"', "truth value"),
      ],)
t("circle",
  [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
   ('radius="3cm"', "measurement", "required"),
   ('fill="true"', "truth value"),
   ('stroke="false"', "truth value"),
      ],)
t("rect",
  [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
   ('width="5cm"', "measurement", "required"),
   ('height="3cm"', "measurement", "required"),
   ('round="1.2cm"', "measurement"),
   ('fill="true"', "truth value"),
   ('stroke="false"', "truth value"),
      ],)

t("grid", 
  [('xs="1in 2in 3in"', "measurements", "required"),
   ('ys="7in 7.2in 7.4in"', "measurements", "required"),
   ])

t("lines", [],
  [("1in 1in 2in 2in", "quadruples of"),
   ("1in 2in 2in 3in", "measurements"),
   ("1in 3in 2in 4in", "representing"),
   ("...", "line segments")])

t("curves", [],
  [("1in 1in 2in 2in 2in 3in 1in 3in", "octtuples of"),
   ("1in 2in 2in 3in 2in 4in 1in 4in", "measurements"),
   ("1in 3in 2in 4in 2in 5in 1in 5in", "representing"),
   ("...", "Bezier curves")])

t("image",
  [('file="cute.jpg"', "string", "required"),
      ('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
   ('width="5cm"', "measurement"),
   ('height="3cm"', "measurement"),
      ],)

t("place", [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
   ('width="5in"', "measurement", "required"),
   ('height="3in"', "measurement", "required"),],
  [("<para>...</para>", "(Sequence of"),
   ("...", "top level"),
   ("<illustration>...</illustration>", "flowables)")])

t("doForm", [('name="logo"', "string", "required"),])

t("plugInGraphic", [('module="mymodule"', "string", "required"),
                     ('function="myfunction"', "string", "required")],
  [("string data for plug in", "unformatted data")])

t("path",
  [('x="1in"', "measurement", "required"),
   ('y="7in"', "measurement", "required"),
   ('close="true"', "truth value"),
   ('fill="true"', "truth value"),
   ('stroke="false"', "truth value"),
      ],
  [ ("1in 6in", "measurement pairs"),
    ("1in 7in", "representing points"),
    ("...", "or path operations"),
      ])

print "<h2>Path Operations</h2>"

t("moveTo", [], [("5in 3in", "measurement pair")])
t("curvesTo", [],
  [("1in 1in 1in 4in 4in 4in", "sextuples of"),
   ("2in 2in 2in 5in 5in 5in", "measurements for"),
   ("...", "bezier curves"),
      ])


h1("Graphical State Change Operations")

t("fill", [('color="blue"', "string name", "required")])

t("stroke", [('color="blue"', "string name", "required")])

t("setFont",
  [('name="Helvetica"', "string name", "required"),
   ('size="1cm"', "measurement", "required"),
   ])

t("form", [('name="logo"', "string name", "required"),],
  [("<drawString ...> ...</drawString>", "(Sequence of"),
   ("...", "graphical"),
   ("<place ...>...</place>", "operations)")])

t("catchForms", [('storageFile="storage.data"', "string name", "required"),],)

t("scale",
  [('sx="0.8"', "scale factor", "required"),
   ('sy="1.3"', "scale factor", "required"),])

t("translate",
  [('dx="0.8in"', "measurement", "required"),
   ('dy="1.3in"', "measurement", "required"),])

t("rotate", [('degrees="45"', "angle in degrees", "required")])

t("skew", [('alpha="15"', "angle in degrees", "required"),
           ('beta="5"', "angle in degrees", "required"),
           ])

t("transform", [],
  [("1.0 0.3","six number affine"),
   ("-0.2 1.1", "transformation"),
   ("10.1 15", "matrix")
      ])

t("lineMode", [
    ('width="0.2cm"', "measurement"),
    ('dash=".1cm .2cm"', "measurements"),
    ('join="round"', '"round", "mitered", or "bevelled"'),
    ('cap="square"', '"default", "round", or "square"'),
    ])

h1("Style Elements")

t("initialize", [],
  [ ("<alias.../>", "sequence of"),
    ("<name.../>", "alias, name"),
    ("<color.../>", "or color tags")
      ])

t("paraStyle",
  [ ('name="mystyle"', "string"),
    ('alias="pretty"', "string"),
    ('parent="oldstyle"', "string"),
    ('fontname="Courier-Oblique"', "string"),
    ('fontsize="13"', "measurement"),
    ('leading="20"', "measurement"),
    ('leftIndent="1.25in"', "measurement"),
    ('rightIndent="2.5in"', "measurement"),
    ('firstLineIndent="0.5in"', "measurement"),
    ('spaceBefore="0.2in"', "measurement"),
    ('spaceAfter="3cm"', "measurement"),
    ('alignment="justify"', '"left", "right", "center" or "justify"'),
    ('bulletFontname="Courier"', "string"),
    ('bulletFontsize="13"', "measurement"),
    ('bulletIndent="0.2in"', "measurement"),
    ('textColor="red"', "string"),
    ('backColor="cyan"', "string"),
      ],)

t("blockTableStyle",
  [ ('id="mytablestyle"', "string"),],
  [ ('<blockFont.../>', "table style"),
    ('<blockLeading.../>', "block descriptors"),
    "...",
      ])

print "<h2>Table Style Block Descriptors</h2>"

t("blockFont",
  [ ('name="TimesRoman"', "string", "required"),
    ('size="8"', "measurement"),
    ('leading="10"', "measurement"),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockLeading",
  [ 
    ('length="10"', "measurement", "required"),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockTextColor",
  [ ('colorName="pink"', "string", "required"),
      ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockAlignment",
  [ ('value="left"', '"left", "right", or "center"'),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockLeftPadding",
  [ ('length="0.2in"', "measurement", "required"),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockRightPadding",
  [ ('length="0.2in"', "measurement", "required"),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockBottomPadding",
  [ ('length="0.2in"', "measurement", "required"),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockTopPadding",
  [ ('length="0.2in"', "measurement", "required"),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockBackground",
  [ ('colorName="indigo"', "string", "required"),
     ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("blockValign",
  [ ('value="left"', '"top", "middle", or "bottom"'),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)
t("lineStyle",
  [ ('kind="BOX"', "line command", "required"),
    ('thickness="4"', "measurement", "required"),
    ('colorName="magenta"', "string", "required"),
    ('start="4"', "integer"),
    ('stop="11"', "integer"),
    ],)

p("""
The line command names are: GRID, BOX,
OUTLINE, INNERGRID, LINEBELOW, LINEABOVE, LINEBEFORE and LINEAFTER. BOX and
OUTLINE are equivalent, and GRID is the equivalent of applying both BOX and INNERGRID.
""")

h1("Page Layout Tags")

t("pageTemplate",
  [ ('id="frontpage"', "string", "required"),],
  [ ('<pageGraphics>...</pageGraphics>...', "optional 1 or 2"),
    ('<frame.../>', "one or more"),
    "...",
      ])

t("frame",
  [ ('id="left"', "string", "required"),
      ('x1="1in"', "measurement", "required"),
   ('y1="1in"', "measurement", "required"),
   ('width="50cm"', "measurement", "required"),
   ('height="90cm"', "measurement", "required"),],)

h1("Special Tags")

t("name",
  [ ('id="chapterName"', "string", "required"),
    ('value="Introduction"', "string", "required"),])

t("alias",
  [ ('id="footerString"', "string", "required"),
    ('value="chapterName"', "string", "required"),])

t("getName",
  [ ('id="footerString"', "string", "required"),])

t("color",
  [ ('id="footerString"', "string", "required"),
    ('RGB="77aa00"', "hexidecimal red/green/blue values"),
    ])

t("pageNumber")

t("outlineAdd", [
    ('level="1"', "integer"),
    ('closed="true"', "truth value"),
    ],
  [ ("Chapter 1, section 2", "outline entry text")
      ])


# print the epilogue
print """
</story>
</document>
"""
